package org.wc;
 
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.Reader;
import java.io.StreamTokenizer;
import java.io.StringReader;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.tomcat.util.http.fileupload.FileItemIterator;
import org.apache.tomcat.util.http.fileupload.FileItemStream;
import org.apache.tomcat.util.http.fileupload.FileUploadException;
import org.apache.tomcat.util.http.fileupload.servlet.ServletFileUpload;
 
 
 
public class WordCount extends HttpServlet {
    public int words = 0;
    public int lines = 0;
    public int chars = 0;
     
    public void wc(Reader r) throws IOException {
        StreamTokenizer tok = new StreamTokenizer(r);
        tok.resetSyntax();
        tok.wordChars(33,255);
        tok.whitespaceChars(0,' ');
        tok.eolIsSignificant(true);
         
        while(tok.nextToken()!=StreamTokenizer.TT_EOF){
            switch(tok.ttype){
                case StreamTokenizer.TT_EOL:
                    lines++;
                    chars++;
                    break;
                case StreamTokenizer.TT_WORD:
                    words++;
                default:
                  chars+=tok.sval.length();
                  break; 
            }
        }
    }
 
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet WordCount</title>");            
            out.println("</head>");
            out.println("<body>");
            out.println("<h3 style=\"color:#0000ff\">Servlet WordCount at " + request.getContextPath() + "</h3>");
            boolean isMultipart = ServletFileUpload.isMultipartContent(request);
            if(isMultipart)
            {    
                ServletFileUpload upload = new ServletFileUpload();
                try {
                    FileItemIterator iter = upload.getItemIterator(request);
                    while (iter.hasNext()) {
                        FileItemStream item = iter.next();
                        // String name = item.getFieldName();
                        InputStream stream = item.openStream();
                        if (!item.isFormField()) {
                            out.println("<h3 style=\"color:#00ff00\">Statistics for text file:</h3>");
                            wc(new InputStreamReader(stream));
                            out.println("<h3 style=\"color:#00ff00\">"+"lines = "+lines+"<br/>words = "+words+"<br/>chars = "+chars+"<br/></h3>");    
                            stream.close();
                            this.init_counter();
                        }
                    }            
                 } catch (FileUploadException ex) { out.println("<h3 style=\"color=#ff0000\">Internal servlet error\n</h3>"); }           
            }    
            else
            {
                String s = request.getParameter("txt_Inp");
                out.println("<h3 style=\"color:#00ff00\">Text statistics:</h3>");
                wc(new StringReader(s));
                out.println("<h3 style=\"color:#00ff00\">"+"lines = "+lines+"<br/>words = "+words+"<br/>chars = "+chars+"<br/></h3>");     
                this.init_counter();
            }
 
            out.println("<br/>");
            out.println("<form>");
            out.println("<input type='button' onclick=\"location='/WordCount';\" value='Redirect to input text'>");
            out.println("</form>");
            out.println("</body>");
            out.println("</html>");
        } finally { out.close();}
     this.init_counter(); // define counters to zero
    }
 
     
// This method uncomment if GET method is used !!!
//    @Override
//    protected void doGet(HttpServletRequest request, HttpServletResponse response)
//            throws ServletException, IOException {
//        processRequest(request, response);
//    }
 
     
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }
 
    @Override
    public String getServletInfo() {
        return "This servlet calculate statistic characteristics of text";
    }
     
    @Override
    public void init(){
     this.init_counter();
    }
     
     private void init_counter(){
      words = 0;
      lines = 0;
      chars = 0;        
    }
}